﻿
// MTG Card Searcher
//
//
//  Sonic-Edge9 ltd.
//
// 	Program by Nino.
//
var bReaded = false;		// カードデータが読み込まれているか、否か
var cardPool;				// 読み込んだカードデータ
var tempCardPool;			// カードデータ処理用（検索結果）
var detailsView;
var idxCardpool;

var mainDeckCard;			// デッキのカードリスト（メイン）
var sideDeckCard;			// デッキのカードリスト（サイド）

var resultContents;			// 最新の検索結果

var defaultValue = "検索文字列を入力してください";		// 未操作判定用
var CR = String.fromCharCode(13);
var LF = String.fromCharCode(10);
var SP = ' ';
//var WSP = '　';
var WSP= /　/g;

var CARD_COUNT = "CardCount";
var CARD_COMMENT = "CardComment";
var PRE_SELECT_M = "SELECTM";
var PRE_SELECT_S = "SELECTS";
var dicNoLimitCards = { "Plains":null, "Island":null, "Swamp":null, "Mountain":null, "Forest":null };

var a;	// 
var iSerial = 0;
// ロード順
var iExpansion = 0;	// 取得対象のエクスパンジョン
var cExpansion = [ "ALA", "10E", "LRW", "MOR", "SHM", "EVE" ];		// カードセットの配列を初期化

var dlg;

var strTargetFilePath;		/// 保存ファイル名まで含む
var strLastFolder;			/// あくまでフォルダー

/// Option 
var opDDetail;		/// Double Click Detail
var opEDisplay;		/// Every Display
var opESearch;		/// Enter Search

function inputCheck() {
	if(!opESearch)
		return;
	if(event.keyCode == 13) {
		searchTest();
	}
}

function copyObj(src, dst) 		// オブジェクトの足し算コピー
{
    copyAllProperty(src, dst);
}

function copyAllProperty(src, dest)
{
	var iexp;
	try {
	    for (var prop in src) {
	    	iexp = 0;
    	    if (typeof(dest[prop]) == "undefined") {
				iexp = 1;
            	dest[prop] = src[prop];
            	for(var subprop in src[prop]) {
					iexp = 2;
            		dest[prop][subprop] = src[prop][subprop];
            	}
        	}
    	}
    } catch( e ) {
    	dalert("exit point = " + iexp);
    }
}

function addCard_Listbox(mtg_card, idx) {
	dalert( mtg_card["cardName"] + " ;; " + mtg_card["cardNameJ"] + " ;; " + mtg_card["manaCost"] + " ;; " + mtg_card["cardType"]);
	var strAction = "ondblclick";
	if(opDDetail) {
		strAction = "onclick";
	}
	var strS = '<item width="200" tooltip="' + mtg_card['cardName'] + '" ' + strAction + '="detailCard(' + idx + ')"><label align="right">' + mtg_card['cardNameJ'] +
	           '   ' + mtg_card['manaCost'] + '   ' + mtg_card['cardType'] + '</label></item>';
	// mtg_card['manaCost'].replace('(', '（') + ' :: '
	//listbox1.tooltip = "Hint de Pint";
	//itm = listbox1.appendElement(strX);
	//itm = listbox1.appendString("適当");
	listbox1.itemSeparator = true;
	listbox1.itemSeparatorColor = "#E0E0E0";
	//listbox1.appendElement(strY);
	var itm = listbox1.appendElement(strS);		//opqrstuwxyz
	/// Debug
	dalert("itm all property" + itm.tooltip );
	for(var elm in buttonL1) {
		dalert( elm ) ;
	}
	dalert("addCard_listbox end");
}

function searchTest() {
	listbox1.removeAllElements();
	// JSONデータを読み切っていたら検索する
	if(bReaded == false) {
		dalert("Not Loaded.");
		return;
	}
	//var sword = $("#inputWord").val().replace(CR, SP);
	var sword = sWords.value;
	sword = sword.replace(LF, SP);
	sword = sword.replace(WSP, SP);
	//alert("Replace after ：" + sword);
	if(sword == defaultValue) {
		dalert("No Searchstring.");
		return;
	} 
	try {
		dalert("Step 1");
		// jQuery 化
		var bAnd = true;	// 固定
		searchWords(sword, bAnd);
		iSerial++;

		dalert("Step 2");
		iSerial++;
		var iTargetCount = 0;	idxCardpool = null; idxCardpool = new Object; //idxCardpool = new Array(100);
		for(var i in tempCardPool) {
			//rtext += carddataLineNoClick(cardPool[i]);
			addCard_Listbox(cardPool[i], iTargetCount);
			
			dalert(" card index ? " + iTargetCount );
			idxCardpool[iTargetCount] = new Object;
			copyObj(cardPool[i], idxCardpool[iTargetCount]);
			//idxCardpool[iTargetCount] = cardPool[i];
			iTargetCount++;
		}
		//rtext += "</tbody></table>";
		

		dalert("Step 2.5");		
	} catch(e) {
		dalert("xsearch" + e.message);
	}
}

// 検索関数
//		検索結果はtempCardPoolに収まる
function searchWords(strWord, bsearchAnd) {
	try {
		////alert(cardPool.length);
		// 検索語の配列用意
		var trgWord = strWord.split(SP);
		// and なら ベースとなる配列は絞り込まれていく。
		// or なら ベースとなる配列は常に一定。
		var baseDic = new Object;
		tempCardPool = new Object;
		copyObj(cardPool, baseDic);
		for(var oIdx= 0; oIdx < trgWord.length; oIdx ++ ) {
			//alert(trgWord[oIdx]);
			if(bsearchAnd == false) {
				baseDic = cardPool;
				//copyObj(cardPool, baseDic);
			} else {
				tempCardPool = null;
				tempCardPool = new Object;
			}
			for(var iIdx in baseDic) {
//				if(cardPool[iIdx]["cardName"].indexOf(trgWord[oIdx])
//						|| cardPool[iIdx]["cardNameJ"].indexOf(trgWord[oIdx])
//						|| cardPool[iIdx]["oracle"].indexOf(trgWord[oIdx])
//						|| cardPool[iIdx]["cardType"].indexOf(trgWord[oIdx])
//						|| cardPool[iIdx]["manaCost"].indexOf(trgWord[oIdx])
//						|| cardPool[iIdx]["cardSet"].indexOf(trgWord[oIdx])) {
				if(typeof(cardPool[iIdx]["cardName"]) == "undefined") {
					dalert("member undefined.");
				}
				for(var mem in cardPool[iIdx]) {
					var stemp = cardPool[iIdx][mem];
					if(stemp.toString().indexOf(trgWord[oIdx]) >= 0) {
						
						tempCardPool[iIdx] = cardPool[iIdx]; // ヒットマーク
					}
				} // else if(cardPool[iIdx]["power"]) {
				//	if(cardPool[iIdx]["power"].indexOf(trgWord[oIdx])) {
				//		resDic[iIdx] = "h"; // ヒットマーク
				//	}
				//}
			}
			if(bsearchAnd == true) {
				baseDic = tempCardPool;
			}
		}
	} catch(e) {
		dalert(e.toString());
		dalert("Search Miss.");
	}
	return;
}

// インデックスに従い、カードセット毎にカードデータをロード
function LoadExpansion() {
	try {

		if(iExpansion < cExpansion.maxCount) {
			dalert("Okashikune : " + iExpansion);
			a = new XMLHttpRequest();
			a.open("GET", "http://www1.parkcity.ne.jp/nino/dmData_" + cExpansion[iExpansion] + ".json", true);
			//a = jQuery.get("http://www1.parkcity.ne.jp/nino/dmData_" + cExpansion[iSel] + ".json", null, displayData);
			a.onreadystatechange = displayData;
			dalert("SET onreadystatechange");
			dalert("Load Expansion = " + iExpansion);
			a.send();
		} else {
			listbox1.appendString("カードデータを読み込みました");
		}
	} catch(e) {
		dalert("koko?");
		MessageBox.show(e);
	}
}

function displayData() {
	try {
 		// Verify that the download completed
		if (a.readyState != 4)
			return;

		// Verify that the download was successful
		if (a.status != 200) {
			a = null;
			return;
		}
		// テスト
		// jQuery化
		tExpansion = eval("("+ a.responseText +")");
		copyObj(tExpansion, cardPool);
		iExpansion = iExpansion + 1;

		bReaded = true;		// 正確には最後まで読めなくてもTrue なので、仕組みを変える必要あり。
		a = null;
		dalert("One Get : " + iExpansion);
		LoadExpansion();
	} catch(e) {
		dalert("Object Fail... " + e.message);
		//MessageBox.show("displayData ...fail");
		bReaded = false;
	}
}

function preLoad() {
	a = null;
	a = new XMLHttpRequest();
	a.open("GET", "http://www1.parkcity.ne.jp/nino/standerd.set", true);
	a.onreadystatechange = preChange;
	a.send();
	
	SetDefault();
	GetOption();
	//listbox1.onGetIsTooltipRequired = true;
}

function preChange() {
	try {
 		// Verify that the download completed
		if (a.readyState != 4)
			return;

		// Verify that the download was successful
		if (a.status != 200) {
			a = null;
			return;
		}
		// テスト
		cExpansion = eval("("+ a.responseText +")");
		cExpansion.maxCount = eval(cExpansion.maxCount);
		dalert("preLoad : " + cExpansion.maxCount);
		a = null;
		LoadExpansion();
	} catch(e) {
		dalert("Object Fail... " + e.message);
		//MessageBox.show("displayData ...fail");
	}
}

function view_onOpen() {
	onLoad();
//	iExpansion = 0;
//	cardPool = new Object;
//	LoadExpansion(iExpansion);
}

function view_onPopin() {
	//view.alert("Popin!!");
}

function view_onPopout() {
	//view.alert("Popout!");
}

function goSearch() {
	// Get words
	var words = sWords.value;
	gadget.debug.trace(words);
	// parse words
	// Search words
	// Display results
}

function getSWords() {
	// 
	var strRes;
	return sWords.value;
}

function goTest() {
	// gadget.storage test
	var strtest = gadget.storage.openText("main.js");
	debug.trace(strtest);

	var strName = framework.BrowseForFile("テキスト|*.txt|画像|*.bmp;*.jpg;*.jpeg");
	debug.trace( strName);

	// FileSystemObject Test
	var fso = framework.system.filesystem;
	var ts;
	//try {

	debug.trace(ts == undefined);
	debug.trace(fso == undefined);

	ts = fso.OpenTextFile(strName);
	str = ts.ReadAll();
	debug.trace(str);


	//} catch( e ) {
	//	debug.error(e);
	//}
}

function onLoad() {
	listbox1.removeAllElements();
	test();
	clearDeck();
}

function test(){
	cardPool = null;
	cardPool = new Object;
	listbox1.removeAllElements();
	iExpansion = 0;
	preLoad();  //LoadExpansion(iExpansion);
	detailsView = null;
  	detailsView = new DetailsView();

	return;

	
	
	
	
	// List box Add elements
	var strX = 	"<item height='40' width='100'  tooltip='testing tooltip!'>" + 
            "<label valign='middle'>kanjiwonyuuryokusiteirutootitesimauApplication nannte hisasiburida. tabun interisence de otiteirunodeha naidarouka..." +
            "</label>" +
            "</item>";
	var strY = "<a href='http://google.com'>Google Home Page </a>";
	var strW = "<item><a href='http://www.secom.co.jp'>Secom </a></item>";
	var strU = "<item width='199' height='40'><label align='left' wordWrap='true'>xx1xx1xx1xx1xx1xx1xx1xx1xx1xx1xx1xx1xx1xx1xx1xx1xx1xx1xx1xx1xx1xx1</label></item>";
	var strT = "<item width='250' height='40' tooltip='floating tips'><edit color='#0F0F0F' width='100' readonly='true' value='aaab' /><edit color='#F0F0F0' width='50' value='b' /></item>";
	var strS = "<item width='200' tooltip='Sanko-madeni'><label align='right'> xx</label></item>";
	listbox1.tooltip = "Hint de Pint";
	//itm = listbox1.appendElement(strX);
	//itm = listbox1.appendString("適当");
	listbox1.itemSeparator = true;
	listbox1.itemSeparatorColor = "#E0E0E0";
	//listbox1.appendElement(strY);
	listbox1.appendElement(strS);		//opqrstuwxyz


}

function detailCard( cname ) {
	var oCard;
	if(cname == undefined) {
		dalert("listbox1 selected index = " + listbox1.selectedIndex);
		dalert("click = " + idxCardpool[listbox1.selectedIndex]["cardName"]);
	} else {
		oCard = new Object;
		dalert("click = " + idxCardpool[cname]["cardName"]);
		copyObj(idxCardpool[cname], oCard);
	}
  	htmlstr = carddataLineNoClick( oCard );

	detailsView.html_content = true;
  	// Create the details view and set its content.
	detailsView.SetContent(
    	"",             // Item's displayed website/news source.
    	undefined,      // Time created
    	htmlstr,  // The XML file
    	false,          // Whether time is shown as absolute time
    	0);             // Content layout flags


	plugin.ShowDetailsView(detailsView, oCard["cardName"], gddDetailsViewFlagNone,  null);
}	

// 検索結果テーブルの１枚
function carddataLineNoClick(obj) {
	var sRet = "";
var strCnvCardName;
strCnvCardName = obj["cardName"].replace(/ /g, "_");
////strCnvCardName = strCnvCardName.replace(/\'/g, "_");
var strTitle = '<a target="_blank" href="http://ww2.wizards.com/Gatherer/CardDetails.aspx?name=' + strCnvCardName + '">'
			   + obj["cardNameJ"] + "</a>";
	
	sRet += "<html><body><font size=\"2\"><b>";
	//sRet += obj["cardNameJ"] + '</b>&nbsp&nbsp&nbsp&nbsp&nbsp';
	sRet += strTitle + '</b>&nbsp&nbsp&nbsp&nbsp&nbsp';
	sRet += obj["manaCost"] + "<br>";
	sRet += obj["cardType"] + "&nbsp&nbsp&nbsp&nbsp&nbsp";
	sRet += obj["cardSet"] +  "&nbsp&nbsp&nbsp&nbsp&nbsp";
	sRet += obj["rare"] + "<br>";
	sRet += obj["oracle"] + "<br>";
	sRet += obj["power"] + "<br>";
	sRet += obj["Illus"] + "<br>";
	sRet += "</body></html>" + CR + LF;
	return sRet;
}

function onSize(){
	var nlh = view.height - listbox1.y -4;
	listbox1.height = nlh;

	if( view.width > 150 ){
		 view.width = 150;
	}

	var nlw = view.width - listbox1.x - 8;
	listbox1.width = nlw;
}

function dalert(iMes) {
	debug.trace(iMes);
	//view.alert(iMes);
}




//////////////////////////////////////////////////////////////////
//
//	デッキからの出し入れ関数
//
//////////////////////////////////////////////////////////////////
//
//
//

function addDialogHeight() {
	var htmlstr = '<html><body width="400" height="400">' + makeDeckHTML() +"</body></html>";
	detailsView.html_content = true;
  	// Create the details view and set its content.
	detailsView.SetContent(
    	"",             // Item's displayed website/news source.
    	undefined,      // Time created
    	htmlstr,  // The XML file
    	false,          // Whether time is shown as absolute time
    	0);             // Content layout flags

	// 橋渡しのオブジェクトを作成して
	var exten = new Object();
 	exten.outMainDeck = outMainDeck;
 	exten.outSideDeck = outSideDeck;
 	detailsView.external = exten;


	plugin.ShowDetailsView(detailsView, "Deck Recipe", gddDetailsViewFlagNone,  null);
}


function makeDeckHTMLForOut() {
	var resTopText = "";
	var resText = "";
	var mLine = 0;
	var sLine = 0;
	for(var elm in mainDeckCard) {
		resText += deckdataLineForOut(cardPool[elm], mLine, mainDeckCard[elm]);
		mLine++;
	}
	if(mLine != 0) {
		resTopText = "<table ,celbadding='5' border='1'>" +
				     "<title></title>" +
					 "<tbody><tr><th>M/S</th>" +
					 "<th>枚数</th>" +
					 "<th>カード名称</th>" +
					 "<th>エキスパンション</th>" +
					 "<th>コスト</th>" +
					 "<th>タイプ</th>" +
					 "<th>P/T</th>" +
					 "<th>コメント</th>" +
					 "</tr>" +
					 "<!-- MAIN CARD -->" +
					 "<tr>" +
					 "<th rowspan='" + mLine + "'>メイン</th>";
		resTopText += resText;
		// サイドボードだけ存在する場面は認めない
		// サイド分
		resText = "";
		for(var elm in sideDeckCard) {
			resText += deckdataLineForOut(cardPool[elm], sLine, sideDeckCard[elm]);
			sLine++;
		}
		if(sLine != 0) {
			resText = "<tr><th rowspan='" + (mLine + 1) + "'>サイド</th>" + resText;
		}
		resTopText = resTopText + resText + "</tbody></table>";
	}
	return resTopText;
}

// カードカウント用のOptionを返す
function makeCardCountOption(cardName, pkey) {
	var iMax = 4;
	if(cardName in dicNoLimitCards) {
		iMax = 40;
	}
	var sRet = '<select name="CardCount" id="' + pkey + cardName + '">';
	for(i = 1; i <= iMax; i++)
    	sRet += "<option value='" + i + "'>" + i;
	return sRet + "</select>";
}

// 制限なしカードかどうか
//		制限なしカード true
//		４枚制限 false
function NoLimits(cardName) {
	var bRet = false;
	if(cardName in dicNoLimitCards) {
		bRet = true;
	}
	return bRet;
}

// デッキ表示用テーブルの１行を生成	
//			返値は文字列
function deckdataLine(obj, Num, line, sJS, pkey) {
	var SEP = "'";
	var sRet = "";
	if(line != 0)
		sRet += "<tr>";
	//sRet += "<td>" + makeCardCountOption(obj["cardName"], pkey) + "</td>";
	sRet += "<td>" + Num + "</td>";
	// デッキ側は、簡単に消えないようにダブルクリックに変更
//	sRet += '<td><div onDblClick="' + sJS + '(' + SEP + obj["cardName"] + SEP + ')">' +
	sRet += "<td><div onDblClick='window.external." + sJS + '("' + obj["cardName"] + '")' + "'>" +
		             obj["cardName"] + '/' +
	                 obj["cardNameJ"] + '</div></td>';
	sRet += "<td>" + obj["cardSet"] + "</td>";
	sRet += "<td>" + obj["manaCost"] + "</td>";
	sRet += "<td>" + obj["cardType"] + "</td>";
	sRet += "<td>" + obj["power"] + "</td>";
	sRet += "<td></td>"
	sRet += "</tr>" + CR + LF;
	return sRet;
}

function makeDeckHTML() {
	var resTopText = "";
	var resText = "";
	var mLine = 0;		var mNum = 0;
	var sLine = 0;		var sNum = 0;
	for(var elm in mainDeckCard) {
		resText += deckdataLine(cardPool[elm], mainDeckCard[elm][CARD_COUNT], mLine, "outMainDeck", PRE_SELECT_M);
		mNum = mNum + mainDeckCard[elm][CARD_COUNT];
		mLine++;
	}
	if(mLine != 0) {
		resTopText = "<table ,celbadding='5' border='1'>" +
				     "<title></title>" +
					 "<tbody><tr><th>M/S</th>" +
					 "<th>枚数</th>" +
					 "<th>カード名称</th>" +
					 "<th>エキスパンション</th>" +
					 "<th>コスト</th>" +
					 "<th>タイプ</th>" +
					 "<th>P/T</th>" +
					 "<th>コメント</th>" +
					 "</tr>" +
					 "<!-- MAIN CARD -->" +
					 "<tr>" +
					 "<th rowspan='" + mLine + "'>メイン<br>" + mNum + "枚</th>";
		resTopText += resText;
		// サイドボードだけ存在する場面は認めない
		// サイド分
		resText = "";
		for(var elm in sideDeckCard) {
			resText += deckdataLine(cardPool[elm], sideDeckCard[elm][CARD_COUNT], sLine, "outSideDeck", PRE_SELECT_S);
			sNum = sNum + sideDeckCard[elm][CARD_COUNT];
			sLine++;
		}
		if(sLine != 0) {
			resText = "<tr><th rowspan='" + sLine + "'>サイド<br>" + sNum + "枚</th>" + resText;
		}
		resTopText = resTopText + resText + "</tbody></table>";
	}
	return resTopText;
}

function createDeck() {
	getCardCount();
	document.getElementById("outputDeckList").value = makeDeckHTMLForOut();
}

// デッキの状態を再表示
function refreshDeck() {
	try {
	getCardCount();
	////document.getElementById("deckList").innerHTML = makeDeckHTML();
	refreshCardCount();
	////document.getElementById("select").change(deckCountChange); //$("select").change(deckCountChange);
	} catch(e) {
		dalert("refreshDeck" + e);
	}
}

// 枚数が変わった
function deckCountChange() {
	// しゃらくさいので全部取得
	getCardCount();
	refreshCardCount();
}

// 現在のカード毎の枚数設定を取得
function getCardCount() {
	try {
		for(var elm in mainDeckCard) {
			mainDeckCard[elm][CARD_COUNT] = document.getElementById(PRE_SELECT_M + elm).selectedIndex + 1;	// ０から始まる
		}
		for(var elm in sideDeckCard) {
			sideDeckCard[elm][CARD_COUNT] = document.getElementById(PRE_SELECT_S + elm).selectedIndex + 1;	// ０から始まる
		}
		//alert(mainDeckCardCount);
	} catch(err) {
		// 枚数チェックしようかなぁ？　基本地形と鼠のチェック面倒だからやめる
		//alert("Error" + err);
	}
}

// カード毎の枚数を再設定
function refreshCardCount() {
	var mainDeckCardCount = 0;
	var sideDeckCardCount = 0;
	for(var elm in mainDeckCard) {
		document.getElementById(PRE_SELECT_M + elm).selectedIndex = mainDeckCard[elm][CARD_COUNT] - 1; // 表示はインデックスの０が１なので
		mainDeckCardCount += mainDeckCard[elm][CARD_COUNT];
	}
	for(var elm in sideDeckCard) {
		document.getElementById(PRE_SELECT_S + elm).selectedIndex = sideDeckCard[elm][CARD_COUNT] - 1; // 表示はインデックスの０が１なので
		sideDeckCardCount += sideDeckCard[elm][CARD_COUNT];
	}
	document.getElementById("mainCardCountDiv").text(mainDeckCardCount + "枚"); //$("#mainCardCountDiv").text(mainDeckCardCount + "枚");
	document.getElementById("sideCardCountDiv").text(sideDeckCardCount + "枚"); //$("#sideCardCountDiv").text(sideDeckCardCount + "枚");
}

// カードを追加
//		メインかサイドかは、cardIn側でラジオボタンをチェックしている
function inDeck(obj) {
	cardIn(obj.id);
	refreshDeck();
}

// リストボックスの選択されているものを削除（サイドから探して行く）
//
function outDeckFromList() {
	var cname;
	try {
		cname = idxCardpool[listbox1.selectedIndex]["cardName"];
		dalert("outDeckFromList " + cname);
		do {
			if(cname in sideDeckCard) {
				cardOut(cname, sideDeckCard);
				break;
			}
			if(cname in mainDeckCard) {
				cardOut(cname, mainDeckCard);
				break;
			}
		} while(false);
		addDialogHeight();
	} catch( e ) {
		dalert( e );
	}
}

// メインからカードを削除
function outMainDeck(obj) {
	cardOut(obj, mainDeckCard);
	refreshDeck();
}
// サイドからカードを削除
function outSideDeck(obj) {
	cardOut(obj, sideDeckCard);
	refreshDeck();
}


// カード名を引数にしてデッキに入れる	sw = 1 --- Main
//                                           2 --- Side
// ばっちいので書き換え
function cardIn(swMain) {
	var cardName;
	try {
		dalert("listbox -- " + listbox1.selectedIndex);
		cardName = idxCardpool[listbox1.selectedIndex]["cardName"];
		dalert(cardName);
		//var iMainOrSide = getRadioBtn("mainside");
		switch (swMain) {
			case 1:
				innerCardIn(cardName, mainDeckCard, sideDeckCard);
				break;
			case 2:
				innerCardIn(cardName, sideDeckCard, mainDeckCard);
				break;
		}
	} catch( e ) {
		dalert( e );
	}
}

// ばっちいので、外だし
function innerCardIn(cardName, dck1, dck2) {
	do {
	if(!(cardName in dck1)) {
		if(cardName in dck2) {
			if(dck2[cardName][CARD_COUNT] > 3)
				break;
		}
		dck1[cardName] = new Object;
		dck1[cardName][CARD_COUNT] = 1;
		dck1[cardName][CARD_COMMENT] = "-";
	} else {
		dck1[cardName][CARD_COUNT] = dck1[cardName][CARD_COUNT] + 1;
		if(NoLimits(cardName) == false) {
			try{
				if(dck1[cardName][CARD_COUNT] > 4)
					dck1[cardName][CARD_COUNT] = dck1[cardName][CARD_COUNT] - 1;
				if(dck1[cardName][CARD_COUNT] + dck2[cardName][CARD_COUNT] > 4)
					dck1[cardName][CARD_COUNT] = dck1[cardName][CARD_COUNT] - 1;
			} catch( e ) {
				dalert("innerCardIn " + e);
			}
		}
	}
	} while(false);	/// ダミーブロック
	if(opEDisplay)
		addDialogHeight();
}

function addMainSide(cardName, keyTwo, value, boolMain) {
	if(boolMain) {
		restoreCard(cardName, keyTwo, value, mainDeckCard);
	} else {
		restoreCard(cardName, keyTwo, value, sideDeckCard);
	}
}

function restoreCard(cardName, keyTwo, value, posDeck) {
	if(!(cardName in posDeck)) {
		posDeck[cardName] = new Object;
		if(keyTwo == CARD_COUNT) {
			posDeck[cardName][keyTwo] = eval(value);
		} else {
			posDeck[cardName][keyTwo] = value;
		}
	} else {
		posDeck[cardName][keyTwo] = value;			/// 枚数ではないデータ
	}
}

function clearDeck() {
	delete mainDeckCard;
	delete sideDeckCard;
	mainDeckCard = new Object;
	sideDeckCard = new Object;
}

// カード名を引数にしてデッキから外す
function cardOut(cardName, deck) {
	if(deck[cardName][CARD_COUNT] > 1) {
		deck[cardName][CARD_COUNT] = deck[cardName][CARD_COUNT] - 1;
	} else {
		delete deck[cardName];
	}
	if(opEDisplay)
		addDialogHeight();
}

// デッキのテキスト用の１行を生成	
//			返値は文字列
function deckdataLineForOut(obj, line, deck) {
	var sRet = "";
	if(line != 0)
		sRet += "<tr>";
	sRet += "<td>" + deck[CARD_COUNT] + "</td>";
	sRet += '<td>' + obj["cardName"] + '/' + obj["cardNameJ"] + '</td>';
	sRet += "<td>" + obj["cardSet"] + "</td>";
	sRet += "<td>" + obj["manaCost"] + "</td>";
	sRet += "<td>" + obj["cardType"] + "</td>";
	sRet += "<td>" + obj["power"] + "</td>";
	sRet += "<td></td>"
	sRet += "</tr>" + CR + LF;
	return sRet;
}

function makeDeckCSV() {
	var resText;
	var k1;
	var k2;
	var v1;
	resText = "##MainDeck##" + CR + LF;
	for(k1 in mainDeckCard) {
		for(k2 in mainDeckCard[k1]) {
			resText += '"' + k1 + '","' + k2 + '","' + mainDeckCard[k1][k2] + '"' + CR + LF;
		}
	}
	resText += "##SideDeck##" + CR + LF;
	for(k1 in sideDeckCard) {
		for(k2 in sideDeckCard[k1]) {
			resText += '"' + k1 + '","' + k2 + '","' + sideDeckCard[k1][k2] + '"' + CR + LF;
		}
	}
	dalert(resText);
	//document.getElementById("saveData").value = resText;
	return resText;
}




//////////////////////////////////////
//
//	New Deck , Load Deck , Save Deck
//
//////////////////////////////////////

function NewDeck() {
	clearDeck();
	alert("デッキクリアしました");
}

function LoadDeck() {
	// gadget.storage test
//	var strtest = gadget.storage.openText("main.js");
//	debug.trace(strtest);

	var strName = framework.BrowseForFile("デッキ|*.dck|すべてのファイル|*.*");
	
	if(strName.length < 2) return;
	
	debug.trace( strName);

	// FileSystemObject Test
	var fso = framework.system.filesystem;
	var ts;
	//try {

	debug.trace(ts == undefined);
	debug.trace(fso == undefined);

	ts = fso.OpenTextFile(strName, 1, 0);

dalert("load file name as " + strName);

	str = ts.ReadAll();
	if(str.indexOf('%22') > 0) {
		str = decodeURI( str );		/// デコード
	}
	debug.trace(str);

var LF = String.fromCharCode(10);

	iMode = 0;
	clearDeck();
	var ar = str.split(LF);
	for(xx = 0; xx < ar.length; xx++ ) {
		dalert(ar[xx]);
	}
	
	for(var i = 0; i < ar.length; i++) {
		strLine = ar[i];
		if(strLine.indexOf("##MainDeck##") >= 0) {
			iMode = 0;
			dalert("##MainDeck##");
		} else if(strLine.indexOf("##SideDeck##") >= 0) {
			iMode = 1;
			dalert("##SideDeck##");
		} else if( strLine.length > 3 ) {
			dalert(" 処理対象 split 前 " + strLine );
			ap = strLine.split('","');	//			ap = split(strLine, """,""")
			if(iMode == 1) {	//			if iMode = 1 then
				addMainSide(ap[0].replace('"', ''), ap[1], ap[2].replace('"',''), false);
			} else {
				addMainSide(ap[0].replace('"', ''), ap[1], ap[2].replace('"',''), true);
			}
			dalert(ap[0] + ap[1] + ap[2]);
		} else {
			// NOP
		}
	}

	//} catch( e ) {
	//	debug.error(e);
	//}
}

//function getFolderPath(){ 
//        var objShell = new ActiveXObject("Shell.Application"); 
//        var objFolder = objShell.BrowseForFolder(0, "Save file in...", 0);   // This works in both Vista & XP 

//        if(objFolder != null){ 
//                return objFolder.self.Path;      // returns selected folder path as a string 
//        } 
//        return null; 
//} 

function SaveDeck() {
	BrowseForSave(OpSaveDeck);
	return;
	
	
}

function OpSaveDeck() {
	//strTargetFilePath;
	var saveText = encodeURI( makeDeckCSV() );		/// 文字コード？？？？
	var op = dlg.detailsViewData.getValue("Operation");
	
	//var saveName = "";

	//framework.BroseForFileMode = BROWSE_FILE_MODE_SAVEAS;

	//var strName = framework.BrowseForFile("デッキ|*.dck");

	var fso = framework.system.filesystem;
	var ts;
	
	if(op == "###SAVE CANCEL###" ) {
		return;
	} else if(op == "###EXPORT###") {
		/// Export Save
		saveText = makeDeckHTML();
		dalert(saveText);
		ts = fso.CreateTextFile(strTargetFilePath, true, false);
		ts.Write(saveText);
	} else {
		/// Normal Save
		ts = fso.CreateTextFile(strTargetFilePath, true, false);
		ts.Write(saveText);
	}
}


////////////////////////////////////////////////////////////////////////////
//
//	karidet
//
/////////////////////////////////////

//<meta HTTP-EQUIV="Refresh" CONTENT="0;URL=ダウンロードさせるファイルのURL">

function BrowseForSave(onCloseFire) {
  dlg = new DetailsView();
  dlg.html_content = false;
  // Create the details view and set its content.
  dlg.SetContent(
      "xx",             // Item's displayed website/news source.
      123,      // Time created
      "details.xml",  // The XML file
      false,          // Whether time is shown as absolute time
      0);             // Content layout flags

	dlg.detailsViewData.putValue("SetTargetFileName", SetTargetFileName);
	dlg.detailsViewData.putValue("closeDlg", closeDlg);
	dlg.detailsViewData.putValue("Operation", "###SAVE CANCEL###");
  // // Set a reference to the "closeDetailsView" function in the detailsViewData
  // dlg.detailsViewData.putValue("closeDetailsView", closeDetailsView);
  
  // Show the details view  
  plugin.ShowDetailsView(dlg,  // The DetailsView object
      "H O Z O N",     // The title
      gddDetailsViewFlagNone,  // Flags
      onCloseFire);
      //null);
      //onDetailsViewFeedback);  // The handler to call when details view closes

}

function closeDlg() {
  plugin.CloseDetailsView();
}

//function SetTargetFileName(strFilePath) {
function SetTargetFileName(strFilePath) {
	strTargetFilePath = strFilePath;
	dalert( "main.js " + strFilePath);
	//options.putValue("LastFolderPath", strFilePath);
}


function GetOption() {
	/// 全部のオプションをココで読み取る？んでよい？
	strLastFolder = options.getValue("LastFolderPath");
	onOptionChanged();
}

function SetDefault() {
	options.putDefaultValue("LastFolderPath", "");
}


///
///
///
///

function onOptionChanged() {
///		-- Double Click Detail
///		-- Sinble Click Detail
	if(options.getValue("DoubleDetail") == "ON") {
		opDDetail = true;
	} else {
		opDDetail = false;
	}

///		-- display deck, when Deck Add, Side Add each action 
///		-- noDisplay.
	if(options.getValue("EveryDisplay") == "ON") {
		opEDisplay = true;
	} else {
		opEDisplay = false;
	}

///		-- Enter --> Seach
///		-- Only Search Button.
	if(options.getValue("EnterSearch") == "ON") {
		opESearch = true;
	} else {
		opESearch = false;
	}
}